#include <windows.h>
//#include <process.h>
#include <stdio.h>
#include <stdlib.h>

#define NAME_PORT    "COM1"

void open_port(void);
void init_port(void);
void read_port(void);

HANDLE hPort;

int main(void)
{
	open_port();
	init_port();
	read_port();
	CloseHandle(hPort);

	return 0;
}

void open_port(void)
{
	hPort = CreateFile(NAME_PORT,GENERIC_READ,0,NULL, \
		OPEN_EXISTING,FILE_FLAG_OVERLAPPED,NULL);
	if( hPort == INVALID_HANDLE_VALUE )
	{
		printf("Error: CreateFile\n");
		exit(1);
	}
	else printf("Open port OK!\n");
}

void init_port(void)
{
	DCB dcb = {0};
	COMMTIMEOUTS timeOuts = {0};
	COMMPROP cp = {0};

	dcb.DCBlength = sizeof(DCB);
	dcb.BaudRate = CBR_115200;
	dcb.fBinary = TRUE;
	dcb.ByteSize = 8;
	if( !SetCommState(hPort,&dcb) )
	{
		printf("Error: SetCommState\n");
		exit(1);
	}
	else printf("SetCommState OK!\n");

	timeOuts.ReadIntervalTimeout = MAXDWORD;
//	timeOuts.ReadTotalTimeoutConstant = 0x01;
//	timeOuts.ReadTotalTimeoutMultiplier = 0x01;
	if( !SetCommTimeouts(hPort,&timeOuts) )
	{
		printf("Error: SetCommTimeouts\n");
		exit(1);
	}
	else printf("SetCommTimeouts OK!\n");

	if( !SetCommMask(hPort,EV_RXCHAR) )
	{
		printf("Error: SetCommMask\n");
		exit(1);
	}
	else printf("SetCommTimeouts OK!\n");
}

void read_port(void)
{
	OVERLAPPED ov = {0};
	DWORD dwEvtMask,size=0,temp;
	char buff[100];

	ov.hEvent = CreateEvent(NULL,FALSE,FALSE,NULL);
	

	for(;;)
	{
		printf("FOR Start\n");
		if( !WaitCommEvent(hPort,&dwEvtMask,&ov) )
		{
			DWORD error;
			error = GetLastError();

			printf("WaitCommEvent return FALSE\n");
			
			if( error == ERROR_IO_PENDING )
			{
				printf("GetLastError return ERROR_IO_PENDING\n");
			}
			else
			{
				printf("GetLastError return %u\n",error);
			}
			GetOverlappedResult(hPort,&ov,&temp,TRUE);
		}
		ReadFile(hPort,buff,15,&temp,&ov);
		if( ov.InternalHigh )
		{
			printf("Read port char = %u\n",ov.InternalHigh);
			buff[ov.InternalHigh] = 0;
			printf("buff = %s\n",buff);
			
			if( buff[0] == 'Q' ) return;
		}
		else printf("Read port char = 0\n");

		printf("FOR end\n\n");
	}
}

/*
OVERLAPPED ovWrite = {0};
	DWORD dwWrite;

	ovWrite.hEvent = CreateEvent(NULL,TRUE,FALSE,NULL);
	ReadFile(ghPort,lpBuff,dwSize,&dwWrite,&ovWrite);

	CloseHandle(ovWrite.hEvent);

	PurgeComm(ghPort,PURGE_RXABORT|PURGE_RXCLEAR);
*/
